import { AfterViewChecked, AfterViewInit, ApplicationRef, ChangeDetectorRef, ElementRef, EventEmitter, Injector, KeyValueDiffers, OnChanges, OnDestroy, OnInit, Renderer2, SimpleChanges, ViewContainerRef } from '@angular/core';
import dayjs from 'dayjs';
import { NgxDaterangepickerBootstrapComponent } from "../components/daterangepicker/ngx-daterangepicker-bootstrap.component";
import { NgxDaterangepickerLocaleService } from "../services/ngx-daterangepicker-locale.service";
import * as i0 from "@angular/core";
export declare class NgxDaterangepickerBootstrapDirective implements OnInit, OnDestroy, OnChanges, AfterViewInit, AfterViewChecked {
    private viewContainerRef;
    private injector;
    private applicationRef;
    private differs;
    private elementRef;
    private _changeDetectorRef;
    private _el;
    private _renderer;
    private _localeService;
    $event: any;
    daterangepicker: NgxDaterangepickerBootstrapComponent | any;
    private daterangepickerRef;
    private readonly daterangepickerElement;
    private localeDiffer?;
    private firstMonthDayClass?;
    private _onChange;
    private _onTouched;
    private _disabled?;
    private _value;
    private _startKey;
    private _endKey;
    private _locale;
    private _resizeObserver?;
    minDate?: dayjs.Dayjs;
    maxDate?: dayjs.Dayjs;
    autoApply?: boolean;
    alwaysShowCalendars?: boolean;
    showCustomRangeLabel?: boolean;
    linkedCalendars?: boolean;
    dateLimit: number | null;
    singleDatePicker?: boolean;
    showWeekNumbers?: boolean;
    showISOWeekNumbers?: boolean;
    showDropdowns?: boolean;
    isInvalidDate?: Function;
    isCustomDate?: Function;
    isTooltipDate?: Function;
    showClearButton?: boolean;
    customRangeDirection?: boolean;
    ranges: any;
    opens: string;
    drops: string;
    lastMonthDayClass?: string;
    emptyWeekRowClass?: string;
    emptyWeekColumnClass?: string;
    firstDayOfNextMonthClass?: string;
    lastDayOfPreviousMonthClass?: string;
    keepCalendarOpeningWithRange?: boolean;
    showRangeLabelOnInput?: boolean;
    showCancel: Boolean;
    lockStartDate: Boolean;
    closeOnAutoApply: boolean;
    timePicker: Boolean;
    timePicker24Hour: Boolean;
    timePickerIncrement: Number;
    timePickerSeconds: Boolean;
    formlyCustomField: Boolean;
    set startKey(value: any);
    set endKey(value: any);
    set locale(value: any);
    get disabled(): boolean | undefined;
    get locale(): any;
    change: EventEmitter<Object>;
    rangeClicked: EventEmitter<Object>;
    datesUpdated: EventEmitter<Object>;
    startDateChanged: EventEmitter<Object>;
    endDateChanged: EventEmitter<Object>;
    clearClicked: EventEmitter<void>;
    notForChangesProperty: Array<string>;
    get value(): any;
    set value(val: any);
    constructor(viewContainerRef: ViewContainerRef, injector: Injector, applicationRef: ApplicationRef, differs: KeyValueDiffers, elementRef: ElementRef, _changeDetectorRef: ChangeDetectorRef, _el: ElementRef, _renderer: Renderer2, _localeService: NgxDaterangepickerLocaleService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onBlur(): void;
    open(event?: any): void;
    hide(e?: any): void;
    toggle(e?: any): void;
    clear(): void;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(state: boolean): void;
    private setValue;
    ngAfterViewChecked(): void;
    onWindowResize(): void;
    pickerResizeObserver(): void;
    /**
     * Set position of the calendar, this works as expected only if you add daterangepickerElement to DOM body
     */
    setPosition(): void;
    getOffset(element: any): {
        top: any;
        left: any;
        height: any;
        width: any;
    };
    inputChanged(e: any): void;
    /**
     * For click outside of the calendar's container
     * @param event event object
     */
    outsideClick(event: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxDaterangepickerBootstrapDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgxDaterangepickerBootstrapDirective, "input[ngxDaterangepickerBootstrap]", never, { "minDate": { "alias": "minDate"; "required": false; }; "maxDate": { "alias": "maxDate"; "required": false; }; "autoApply": { "alias": "autoApply"; "required": false; }; "alwaysShowCalendars": { "alias": "alwaysShowCalendars"; "required": false; }; "showCustomRangeLabel": { "alias": "showCustomRangeLabel"; "required": false; }; "linkedCalendars": { "alias": "linkedCalendars"; "required": false; }; "dateLimit": { "alias": "dateLimit"; "required": false; }; "singleDatePicker": { "alias": "singleDatePicker"; "required": false; }; "showWeekNumbers": { "alias": "showWeekNumbers"; "required": false; }; "showISOWeekNumbers": { "alias": "showISOWeekNumbers"; "required": false; }; "showDropdowns": { "alias": "showDropdowns"; "required": false; }; "isInvalidDate": { "alias": "isInvalidDate"; "required": false; }; "isCustomDate": { "alias": "isCustomDate"; "required": false; }; "isTooltipDate": { "alias": "isTooltipDate"; "required": false; }; "showClearButton": { "alias": "showClearButton"; "required": false; }; "customRangeDirection": { "alias": "customRangeDirection"; "required": false; }; "ranges": { "alias": "ranges"; "required": false; }; "opens": { "alias": "opens"; "required": false; }; "drops": { "alias": "drops"; "required": false; }; "lastMonthDayClass": { "alias": "lastMonthDayClass"; "required": false; }; "emptyWeekRowClass": { "alias": "emptyWeekRowClass"; "required": false; }; "emptyWeekColumnClass": { "alias": "emptyWeekColumnClass"; "required": false; }; "firstDayOfNextMonthClass": { "alias": "firstDayOfNextMonthClass"; "required": false; }; "lastDayOfPreviousMonthClass": { "alias": "lastDayOfPreviousMonthClass"; "required": false; }; "keepCalendarOpeningWithRange": { "alias": "keepCalendarOpeningWithRange"; "required": false; }; "showRangeLabelOnInput": { "alias": "showRangeLabelOnInput"; "required": false; }; "showCancel": { "alias": "showCancel"; "required": false; }; "lockStartDate": { "alias": "lockStartDate"; "required": false; }; "closeOnAutoApply": { "alias": "closeOnAutoApply"; "required": false; }; "timePicker": { "alias": "timePicker"; "required": false; }; "timePicker24Hour": { "alias": "timePicker24Hour"; "required": false; }; "timePickerIncrement": { "alias": "timePickerIncrement"; "required": false; }; "timePickerSeconds": { "alias": "timePickerSeconds"; "required": false; }; "formlyCustomField": { "alias": "formlyCustomField"; "required": false; }; "startKey": { "alias": "startKey"; "required": false; }; "endKey": { "alias": "endKey"; "required": false; }; "locale": { "alias": "locale"; "required": false; }; }, { "change": "change"; "rangeClicked": "rangeClicked"; "datesUpdated": "datesUpdated"; "startDateChanged": "startDateChanged"; "endDateChanged": "endDateChanged"; "clearClicked": "clearClicked"; }, never, never, true, never>;
}
